// HPC++ Run Time Sytem Library
// Extreme! Computing Lab - Computer Science Department
// Copyright (c) 1997 Indiana University
// Authors: Pete Beckman, Dennis Gannon, Todd Green, and Liz Johnson
//
// $Id: hpcxx_invokeImpl.cc,v 1.1 1999/04/17 01:19:32 kate Exp $

#include <hpcxx_invoke.h>
#include <hpcxx_register.h>
#include <HPCxx_Buffer.h>


template <class T>
void hpcxx_pack(HPCxx_Buffer &buffer, HPCxx_GlobalPtr<T> *r, int count) {
  int sz = count*nexus_sizeof_startpoint((*(r[0])).contextID_, 1)
	    + count*sizeof(int) + 32;
  if(nexus_check_buffer_size(buffer.impl_.buffer_, sz, sz, 0, 0) < 0) {
    cout << "global pointer pack failed" << endl;
  }
  for (int i = 0; i < count; i++) {
    HPCxx_GlobalRefImpl<T> &gr = *(r[i]);
    nexus_startpoint_t *sp = new nexus_startpoint_t;
    nexus_startpoint_copy(sp,  gr.contextID_);
    nexus_put_startpoint_transfer(buffer.impl_.buffer_ , sp, 1);
    nexus_put_int(buffer.impl_.buffer_, &(gr.offset_), 1);
  }
}


template <class T>
void hpcxx_unpack(HPCxx_Buffer &buffer, HPCxx_GlobalPtr<T> *r, int count) {
  for (int i = 0; i < count; i++) {
    HPCxx_GlobalRefImpl<T> &gr = *(r[i]);
    gr.contextID_ = new nexus_startpoint_t;     
    nexus_get_startpoint(buffer.impl_.buffer_,gr.contextID_, 1); 
    nexus_get_int(buffer.impl_.buffer_, &(gr.offset_), 1 );  
    gr.localPtr_ = NULL;
    gr.GlobalEndpoint = NULL;
  }
}


template <class T>
void hpcxx_pack(HPCxx_Buffer &buffer, HPCxx_Sync<T> *r, int count) {
  for (int i = 0; i < count; i++) {
    T x = r[i];		// i am fairly certain this is wrong! dbg.
    nexus_startpoint_t sp ;
    HPCxx_GlobalRefImpl<T> gpi(&x);
    nexus_startpoint_copy(&sp,  gpi.contextID_);
    nexus_put_startpoint_transfer(buffer.impl_.buffer_ , &sp, 1);
    nexus_put_int(buffer.impl_.buffer_, &gpi.offset_, 1);
  }
}
